package com.ilstechnology.androidkitilsv2;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;


public class organizations extends ListActivity {

    String response_;

    List<String>  orgsID=new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        final JSONParser jSon = new JSONParser();
        try{
        super.onCreate(savedInstanceState);
        setContentView(R.layout.organizations);
            TextView text = (TextView) findViewById(R.id.welcome_tv);
            if(Global.name == null){
                text.setText("Welcome    ");
            }else{
                text.setText("Welcome, " + Global.name +"      ");
            }

            ExecutorService executorService = Executors.newFixedThreadPool(1);
            Future<String> future=   executorService.submit(new CallableTask());

                response_ = future.get();
                System.out.println("------Response-----"+response_);
                JSONObject jsonObj = new JSONObject(response_);
                JSONObject auth = jsonObj.getJSONObject("data");
                boolean success = auth.getBoolean("success");
                final List<String> orgsString;

                if (success) {
                    JSONObject params = auth.getJSONObject("params");
                    JSONArray orgJsonArray = params.getJSONArray("result");
                    System.out.println(orgJsonArray);
                    orgsString  = addChecked3(orgJsonArray, 0);

                    final ListView myListView = (ListView) findViewById(android.R.id.list);
                    myListView.setTextFilterEnabled(true);
                    myListView.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, orgsString));
                    myListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                        public void onItemClick(AdapterView<?> myAdapter, View myView, int myItemInt, long mylng) {
                            String selectedFromList = (String) (myListView.getItemAtPosition(myItemInt));
                            System.out.println("===Position====="+myItemInt);
                            System.out.println("===ID=====" + orgsID.get(myItemInt));
                            Global.organizations = orgsString.get(myItemInt).trim();
                            Thread thread = new Thread(new Runnable(){
                                @Override
                                public void run() {
                                    try {
                                        if (!Global.prevOrg.equals(Global.organizations)){
                                            String json = "{\"auth\":{\"sessionId\":\"" + Global.sessionId + "\"},\"cmd\":{\"command\":\"session.org.switch\",\"params\":{\"key\":\"" + Global.organizations + "\"}}}";
                                            response_ = jSon.xHttpPost("http://api.devicewise.com/api", json);
                                            System.out.println(json + "------Response Switch-----" + response_);
                                            //   JSONObject jsonObj1 = new JSONObject(response);
                                            //   JSONObject auth1 = jsonObj1.getJSONObject("cmd");
                                            //   boolean success1 = auth1.getBoolean("success");
                                        }
                                        Intent i = new Intent(organizations.this, things.class);
                                        startActivity(i);
                                    } catch (Exception e) {
                                        e.printStackTrace();
                                    }
                                }
                            });
                            thread.start();

                        }
                    });
                }

            } catch (Exception e) {
                e.printStackTrace();
            }
    }

    public  List<String> addChecked3(JSONArray ja,int spaces) throws JSONException {
        List<String> orgsKEY=new ArrayList<>();
        for (int i = 0; i < ja.length(); i++) {
            JSONObject jo = (JSONObject) ja.get(i);
            String id = spaces_(spaces) + jo.getString("orgId");
            String key = spaces_(spaces) + jo.getString("orgKey");
            System.out.println("hi"+ id);
            orgsID.add(id);
            orgsKEY.add(key);
            if (jo.has("subOrgs")) {
                List<String> subs = addChecked3((JSONArray) jo.get("subOrgs"), spaces + 1);
                orgsID.addAll(subs);
                orgsKEY.addAll(subs);
            }
        }
        return orgsKEY;
    }



    public String spaces_(int space){
        String total = "";
        for (int i = 0; i < space; i++) {
            total = total + "\t";
        }
        return total;
    }



    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_organizations, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
