package com.ilstechnology.androidkitilsv2;

import android.content.Intent;
import android.graphics.Color;
import android.graphics.Typeface;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.util.TypedValue;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.Space;
import android.widget.Spinner;
import android.widget.TableLayout;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.LinearLayout.LayoutParams;

import org.json.JSONObject;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


public class thing_method extends ActionBarActivity {

    ArrayList<method> meth = new ArrayList<method>();
    ArrayList<String> nameList = new ArrayList<String>();
    String methodSelected;
    ArrayList<String> typeList = new ArrayList<String>();
    ArrayList<String> valueList = new ArrayList<String>();
    String response_;
    List<EditText> etList = new ArrayList<EditText>();
    ArrayList<String> getValueMethod = new ArrayList<String>();

    Boolean getout = false;

    //Class with Method Detail
    public class detailMethod {
        ArrayList<String> value;
        ArrayList<String> type;

        //constructor
        public detailMethod(){
            value = new ArrayList<String>();
            type = new ArrayList<String>();
        };

        public void add(String a, String b) {
            value.add(a);
            type.add(b);
        }


    }

    //Class with the method name and detail Method
    public class method {
        String name;
        detailMethod arrayMethods;
        //constructor
        method(String n, detailMethod d) {
            this.name = n;
            this.arrayMethods = d;
        }

        method(){}

        String getName(){
            return name;
        }
    }


    final JSONParser jSon = new JSONParser();
    final JSONParser jSon1 = new JSONParser();
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.thing_method);
        final Thread thread = new Thread(new Runnable(){

            @Override
            public void run() {
                try {

                    String json = "{\"auth\":{\"sessionId\":\"" + Global.sessionId + "\"},\"cmd\":{\"command\":\"thing_def.find\",\"params\":{\"key\":\"" + thing_details.defKey + "\"}}}";

                    String response_ = jSon.xHttpPost("http://api.devicewise.com/api", json);
                    System.out.println(json + "------Response Thing Definition-----" + response_);

                    JSONObject jsonObj = new JSONObject(response_);
                    JSONObject auth = jsonObj.getJSONObject("cmd");
                    boolean success = auth.getBoolean("success");
                    if (success) {
                        JSONObject params = auth.getJSONObject("params");
                        if(params.has("methods")) {
                                //props
                            JSONObject jsonMethods = params.getJSONObject("methods");
                                Iterator<?> keys = jsonMethods.keys();
                                while( keys.hasNext() ) {

                                    String key = (String)keys.next();
                                    detailMethod det = new detailMethod();

                                    JSONObject value = jsonMethods.getJSONObject(key);
                                    JSONObject notificationVar = value.getJSONObject("notificationVariables");
                                    Iterator<?> sub_keys = notificationVar.keys();
                                    while( sub_keys.hasNext() ) {
                                        String sub_key = (String)sub_keys.next();
                                        JSONObject value_ = jsonMethods.getJSONObject(key);
                                        JSONObject valueByMethod_ = notificationVar.getJSONObject(sub_key);
                                        String getValue = valueByMethod_.getString("type");
                                        det.add(sub_key, getValue );
                                    }

                                    meth.add(new method(key, det));
                                    nameList.add(key);

                                }
                            }else{

                            }

                        }

                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
        thread.start();
        try {
            thread.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                //Methods dropdown
                Spinner dropdown = (Spinner) findViewById(R.id.method);
                ArrayAdapter<String> adapter = new ArrayAdapter<String>(getApplicationContext(), R.layout.spinner_item, nameList);
                dropdown.setAdapter(adapter);
                dropdown.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
                    @Override
                    public void onItemSelected(AdapterView<?> parent, View selectedItemView, int pos, long id) {
                        Toast.makeText(getApplicationContext(), "The method selected is " +
                                parent.getItemAtPosition(pos).toString(), Toast.LENGTH_LONG).show();
                        methodSelected = parent.getItemAtPosition(pos).toString();

                        for (int i = 0; i < meth.size(); i++) {
                            if (parent.getItemAtPosition(pos).toString() == nameList.get(i)) {
                                int positionM = i;
                                typeList = meth.get(positionM).arrayMethods.type;
                                valueList = meth.get(positionM).arrayMethods.value;
                            }
                        }
                        LinearLayout layout = (LinearLayout) findViewById(R.id.ly);
                        LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(
                                android.widget.LinearLayout.LayoutParams.MATCH_PARENT,
                                android.widget.LinearLayout.LayoutParams.WRAP_CONTENT);
                        layout.setPadding(0, 15, 0, 0);

                        int childcount = layout.getChildCount();
                        for (int i=0; i < childcount; i++){
                            View v = layout.getChildAt(i);
                            if(layout.getChildAt(i) instanceof TextView){
                                layout.removeView(layout.getChildAt(i));
                            }
                            if(layout.getChildAt(i) instanceof EditText){
                                layout.removeView(layout.getChildAt(i));
                            }
                            if(layout.getChildAt(i) instanceof Space){
                                layout.removeView(layout.getChildAt(i));
                            }
                            if(layout.getChildAt(i) instanceof Button){
                                layout.removeView(layout.getChildAt(i));
                            }
                        }

                        for (int i = 0; i < typeList.size(); i++) {

                            // text view
                            TextView tv = new TextView(getApplicationContext());
                            tv.setLayoutParams(new TableLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
                            tv.setText(valueList.get(i));
                            tv.setTextSize(TypedValue.COMPLEX_UNIT_SP, 18);
                            tv.setTextColor(Color.parseColor("#737374"));
                            tv.setLayoutParams(params);
                            layout.addView(tv);

                            EditText edttext = new EditText(getApplicationContext());
                            edttext.setLayoutParams(new TableLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
                            edttext.setLayoutParams(params);
                            edttext.setId(i);
                            edttext.setTextColor(Color.parseColor("#737374"));
                            layout.addView(edttext);
                            etList.add(edttext);
                        }

                        Space sp = new Space(getApplicationContext());
                        LinearLayout.LayoutParams params_ = new LinearLayout.LayoutParams(
                                LayoutParams.WRAP_CONTENT, 30);
                        sp.setLayoutParams(params_);
                        layout.addView(sp);

                        Button bt = new Button(getApplicationContext());
                        bt.setText("Exec Method");
                        bt.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.WRAP_CONTENT));
                        layout.addView(bt);


                        bt.setOnClickListener(new View.OnClickListener() {
                            @Override
                            public void onClick(View v) {
                                Thread thread_ = new Thread(new Runnable() {
                                    @Override
                                    public void run() {
                                        try {
                                            for (EditText et : etList) {
                                                if(et.getText().toString().length() == 0){
                                                    runOnUiThread(new Runnable() {
                                                        public void run() {
                                                            Toast.makeText(getApplicationContext(), "Please fill the fields", Toast.LENGTH_SHORT).show();
                                                            getout = true;
                                                        }
                                                    });

                                                }
                                                if(getout == true) return;
                                                getValueMethod.add(et.getText().toString());
                                            }
                                            if(getout == true) return;
                                            String jsonParams = ",\"params\": {";
                                            if (valueList.size() != 0) {
                                                for (int i = 0; i < typeList.size(); i++)  {

                                                    if(typeList.get(i).equals("float") || typeList.get(i).equals("int")){
                                                        jsonParams+= "\""+valueList.get(i)+"\": "+getValueMethod.get(i);
                                                    }else{
                                                        jsonParams+= "\""+valueList.get(i)+"\": \""+getValueMethod.get(i)+"\"";
                                                    }
                                                    if (i != typeList.size() - 1 || typeList.size()!= 1) {
                                                        jsonParams+= ",";
                                                    }
                                                }
                                                jsonParams+= "}";
                                            } else {
                                                jsonParams = "";

                                            }
                                            String json = "{\"auth\": {\"sessionId\": \"" + Global.sessionId + "\"},\"cmd\": {\"command\": \"method.exec\",\"params\": {\"ackTimeout\": 10,\"method\": \"" + methodSelected + "\",\"singleton\": false,\"thingKey\": \"" + Global.thing_selected + "\"" + jsonParams + "}}}";

                                            response_ = jSon.xHttpPost("http://api.devicewise.com/api", json);
                                            System.out.println(json + "------Response Thing Definition-----" + response_);

                                            JSONObject jsonObj = new JSONObject(response_);
                                            textArea();

                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }
                                    }
                                });

                                thread_.start();


                            }
                        });


                    }

                    @Override
                    public void onNothingSelected(AdapterView<?> parentView) {

                    }


                });



            }

            //Method Result
            public void textArea(){
                try {

                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            LinearLayout layout = (LinearLayout) findViewById(R.id.ly);

                            Space sp = new Space(getApplicationContext());
                            LinearLayout.LayoutParams params_ = new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT, 30);
                            sp.setLayoutParams(params_);
                            layout.addView(sp);

                            // text view
                            TextView tv1 = new TextView(getApplicationContext());
                            tv1.setLayoutParams(new TableLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
                            tv1.setText("");
                            tv1.setTextSize(TypedValue.COMPLEX_UNIT_SP, 18);
                            tv1.setTextColor(Color.parseColor("#737374"));
                            tv1.setText(response_);
                            layout.addView(tv1);

                        }
                    });



                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_thing_method, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.logout) {
            Global.sessionId = "";
            startActivity(new Intent(thing_method.this, Main.class));
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
