package com.ilstechnology.androidkitilsv2;

import android.app.ListActivity;
import android.content.Intent;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;
import android.view.WindowManager;
import android.view.Window;


public class things extends ListActivity {

    String response_;
    static ArrayList arrayList = new ArrayList();
    final JSONParser jSon = new JSONParser();
    List<String>  thingKey=new ArrayList<>();
    List<String>  thingName=new ArrayList<>();
    List<Boolean>  thingConn=new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //Remove title bar
        this.requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.things);

        TextView text = (TextView) findViewById(R.id.org);
        if(Global.organizations == null){
            text.setText("");
        }else{
            text.setText("Organization: " + Global.organizations +"      ");
        }
        Thread t = new Thread(new Runnable() {
            public void run() {
                //Request
                String json_ = "{\"auth\": {\"sessionId\": \"" + Global.sessionId + "\"},\"data\": {\"command\": \"thing.list\", \"params\": {\"limit\": \"200\", \"offset\": 0}}}";
                response_ = jSon.xHttpPost("http://api.devicewise.com/api", json_);

                try {
                    //Response
                    System.out.println("------Things-----"+response_);
                    JSONObject jsonObj = new JSONObject(response_);
                    JSONObject auth = jsonObj.getJSONObject("data");
                    boolean success = auth.getBoolean("success");
                    if (success) {
                        JSONObject params = auth.getJSONObject("params");
                        JSONArray mJsonArray = params.getJSONArray("result");
                        int j = 0;
                        JSONObject mJsonObject = new JSONObject();
                        for (int i = 0; i < mJsonArray.length(); i++) {
                            mJsonObject = mJsonArray.getJSONObject(i);
                                thingConn.add(mJsonObject.getBoolean("connected"));
                                thingKey.add(mJsonObject.getString("key"));
                                thingName.add(mJsonObject.getString("name"));
                                j++;
                        }

                    }

                } catch (Exception e) {
                    e.printStackTrace();
                }
            }

        });
        t.start();
        try {
            t.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

        Thread h = new Thread(new Runnable() {
            public void run() {
                final ListView myListView = (ListView) findViewById(android.R.id.list);
                //Populating the list
                myListView.setAdapter(new ArrayAdapter<String>(things.this, android.R.layout.simple_list_item_1, thingName));
                //Clicking an element of the list
                myListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                    public void onItemClick(AdapterView<?> myAdapter, View myView, int myItemInt, long mylng) {
                        String selectedFromList = (String) (myListView.getItemAtPosition(myItemInt));
                        System.out.println("===Thing Position=====" + myItemInt);
                           System.out.println("===ID=====" + thingKey.get(myItemInt));
                           Global.thing_selected = thingKey.get(myItemInt);
                           Intent i = new Intent(things.this, thing_details.class);
                           startActivity(i);

                    }
                });
            }

        });
        h.start();

    }




    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_things, menu);
        return true;
    }




    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
