package com.ilstechnology.androidkitilsv2;

import android.content.Intent;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


public class thing_details extends ActionBarActivity {

    final JSONParser jSon = new JSONParser();

    public static List<String> attrsName=new ArrayList<>();
    public static List<String>  attrsValue=new ArrayList<>();
    public static List<String> propName=new ArrayList<>();
    public static List<String>  propValue=new ArrayList<>();
    public static List<String> alarmName=new ArrayList<>();
    public static List<String>  alarmState=new ArrayList<>();
    public static List<String>  attrsTs=new ArrayList<>();
    public static List<String>  propTs=new ArrayList<>();
    public static List<String>  alarmTs=new ArrayList<>();
    int countProp = 0;
    int countAlarms= 0;
    int countAttrs = 0;
    String createdby;
    boolean connected;
    String lastSeen;
    public static String defKey;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.thing_details);
        Thread thread = new Thread(new Runnable(){
            @Override
            public void run() {
                try {
                //    if (!Global.prevOrg.equals(Global.organizations)){
                        String json = "{\"auth\":{\"sessionId\":\"" + Global.sessionId + "\"},\"cmd\":{\"command\":\"thing.find\",\"params\":{\"key\":\"" + Global.thing_selected + "\"}}}";

                        String response_ = jSon.xHttpPost("http://api.devicewise.com/api", json);
                        System.out.println(json + "------Response Thing-----" + response_);

                        JSONObject jsonObj = new JSONObject(response_);
                        JSONObject auth = jsonObj.getJSONObject("cmd");
                        boolean success = auth.getBoolean("success");
                        if (success) {
                            JSONObject params = auth.getJSONObject("params");

                            propName.clear();
                            propValue.clear();
                            propTs.clear();
                            if(params.has("properties")) {
                                //props
                                JSONObject jsonProps = params.getJSONObject("properties");
                                Iterator<?> keys = jsonProps.keys();
                                while( keys.hasNext() ) {
                                    String key = (String)keys.next();
                                    JSONObject value = jsonProps.getJSONObject(key);
                                    String val = value.getString("value");
                                    String ts = value.getString("ts");
                                    propName.add(key);
                                    propValue.add("Value: " + val);
                                    propTs.add(ts);
                                    countProp++;
                                }
                            }else{
                                countProp = 0;
                            }
                            attrsName.clear();
                            attrsValue.clear();
                            attrsTs.clear();
                            if(params.has("attrs")) {
                                JSONObject jsonAttrs = params.getJSONObject("attrs");
                                Iterator<?> keys = jsonAttrs.keys();
                                while( keys.hasNext() ) {
                                    String key = (String)keys.next();
                                    JSONObject value = jsonAttrs.getJSONObject(key);
                                    String val = value.getString("value");
                                    String ts = value.getString("ts");
                                    attrsName.add(key);
                                    attrsValue.add("Value: " + val);
                                    attrsTs.add(ts);
                                    countAttrs++;
                                }
                            }else{
                                countAttrs = 0;
                            }
                            alarmState.clear();
                            alarmName.clear();
                            alarmTs.clear();
                            if(params.has("alarms")) {
                                JSONObject jsonAlarms = params.getJSONObject("alarms");
                                Iterator<?> keys = jsonAlarms.keys();
                                while( keys.hasNext() ) {
                                    String key = (String)keys.next();
                                    JSONObject value = jsonAlarms.getJSONObject(key);
                                    String val = value.getString("state");
                                    String ts = value.getString("ts");
                                    alarmName.add(key);
                                    alarmState.add("State: " + val);
                                    alarmTs.add(ts);
                                    countAlarms++;
                                }
                            }else{
                                countAlarms = 0;
                            }
                            createdby = params.getString("createdBy");
                            connected = params.getBoolean("connected");
                            lastSeen = params.getString("lastSeen");
                            defKey = params.getString("defKey");
                        }
                 //   }

                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
        thread.start();
        try {
            thread.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                //key
                TextView text_key_ = (TextView)findViewById(R.id.text_key);
                text_key_.setText(Global.thing_selected);
                //created by
                TextView text_createdby_ = (TextView)findViewById(R.id.text_createdby);
                text_createdby_.setText(createdby);
                //Props
                TextView text_props_lenght_ = (TextView)findViewById(R.id.text_props_lenght);
                text_props_lenght_.setText(String.valueOf(countProp));
                //connected
                TextView text_connected_ = (TextView)findViewById(R.id.text_connected);
                boolean con = connected;
                text_connected_.setText(String.valueOf(con));
                //LAST SEEN
                TextView text_lastseen_ = (TextView)findViewById(R.id.text_lastseen);
                text_lastseen_.setText(lastSeen);
                //ATTRIBUTES
                TextView text_attris_lenght_ = (TextView)findViewById(R.id.text_attris_lenght);
                text_attris_lenght_.setText(String.valueOf(countAttrs));
                //ALARMS
                TextView text_alarms_lenght_ = (TextView)findViewById(R.id.text_alarms_lenght);
                text_alarms_lenght_.setText(String.valueOf(countAlarms));

                // btn_attrs
                Button btn_attrs = (Button)findViewById(R.id.btn_attributes);
                if(countAttrs != 0) btn_attrs.setEnabled(true);
                else btn_attrs.setEnabled(false);
                btn_attrs.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        startActivity(new Intent(thing_details.this, thing_attributes.class));
                    }
                });
                // btn_props
                Button btn_props = (Button)findViewById(R.id.btn_properties);
                if(countProp != 0) btn_props.setEnabled(true);
                else btn_props.setEnabled(false);
                btn_props.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        startActivity(new Intent(thing_details.this, thing_properties.class));
                    }
                });

                // btn_alarms
                Button btn_alarms = (Button)findViewById(R.id.btn_alarms);
                if(countAlarms != 0) btn_alarms.setEnabled(true);
                else btn_alarms.setEnabled(false);
                btn_alarms.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        startActivity(new Intent(thing_details.this, thing_alarms.class));
                    }
                });

                // btn_methods
                Button btn_methods = (Button)findViewById(R.id.btn_methods);
                btn_methods.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        startActivity(new Intent(thing_details.this, thing_method.class));
                    }
                });

            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_thing_details, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.logout) {
            Global.sessionId = "";
            startActivity(new Intent(thing_details.this, Main.class));
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
